"{ Package: 'stx:libbasic3' }"

BuildDefinition subclass:#ApplicationDefinition
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'System-Support-Projects'
!


!ApplicationDefinition class methodsFor:'accessing'!

applicationName

^(self moduleDirectory subStrings:$/) first

"
    bosch_dapasx_application applicationName     
"

    "Created: / 08-08-2006 / 20:25:39 / fm"
! !

!ApplicationDefinition class methodsFor:'defaults'!

defaultDescription
    ^ 'an application'
!

guiClassFileNames
    ^ self guiClasses 
        collect:[:cls | (cls classFilename asFilename 
                            withSuffix:(ObjectFileLoader sharedLibrarySuffix))
                                baseName].
!

guiClasses
    ^ DeviceWorkstation allSubclasses 
        select:[:cls | cls isLoaded and:[cls ~~ WinPrinter]]
!

needResources
    ^ self isGUIApplication
! !

!ApplicationDefinition class methodsFor:'description'!

excludedFromPreRequisites  

^#()
!

excludedFromSubProjects

^#()
!

isGUIApplication
"Return true, if this is a GUI app"

^true

    "Created: / 08-08-2006 / 11:15:01 / fm"
!

objectsClassNames

^#()
!

pathToApplicationTop

^''
!

preRequisites

^#()
!

startUpClass

^''
!

startUpSelector

^'start'
! !

!ApplicationDefinition class methodsFor:'file generation'!

fileNamesToGenerate
    ^ #( 
"
          #('Make.proto' #'generate_make_dot_proto')
          #('Make.spec' #'generate_make_dot_spec')
          #('libInit.cc' #'generate_libInit_dot_cc')
"
          #('bc.def' #'generate_bc_dot_def')
          #('nt.mak' #'generate_nt_dot_mak')
          #('modules.stx' #'generate_modules_dot_stx')
"
          #('nt.def' #'generate_nt_dot_def')
          #('abbrev.stc' #'generate_abbrev_dot_stc') 
"
     )
! !

!ApplicationDefinition class methodsFor:'file templates'!

bc_dot_def

^ 
'DESCRIPTION     %(DESCRIPTION)
CODE            PRELOAD MOVEABLE DISCARDABLE
SEGMENTS
    INITCODE    PRELOAD DISCARDABLE
'

    "Created: / 08-08-2006 / 12:26:58 / fm"
    "Modified: / 08-08-2006 / 19:32:27 / fm"
!

modules_dot_stx

^ 
'# $','Header','$
#
# This file is (currently) only used with win-95 / win-NT versions of STX.
# It lists the dll''s which are to be loaded at startup time.
#
# All classes loaded at startup time will be present as precompiled classes.
# Others will be autoloaded.
#
%(PREREQUISITE_LIBS)
%(SUBPROJECT_LIBS)
'

    "Created: / 08-08-2006 / 12:26:58 / fm"
    "Modified: / 08-08-2006 / 19:32:27 / fm"
    "Modified: / 16-08-2006 / 17:56:58 / User"
!

nt_dot_mak
    |def needResources|

    needResources := false "self isGUIApplication".

    def :=
'#
# DO NOT EDIT
# automagically generated from Make.proto (by make nt.mak)
#

CFLAGS1= -WD -w-pro -w-ccc -w-rch -w-aus -w-par -x- -r- -k -y -v -vi- -c -tWDR
CFLAGS1= -w-pro -w-ccc -w-rch -w-aus -w-par -x- -r- -k -y -v -vi- -c

CFLAGS_CONSOLE=
CFLAGS_NOCONSOLE=-tWR -D_NO_VCL;WIN32GUI;WIN32 -DWIN_LOGFILE="\"%(APPLICATION)_%%d.log\""
LFLAGS_CONSOLE=-ap
LFLAGS_NOCONSOLE=-aa
CRT_STARTUP_CONSOLE=c0x32.obj
CRT_STARTUP_NOCONSOLE=c0w32.obj

CFLAGS_APPTYPE=$(CFLAGS_NOCONSOLE)
LFLAGS_APPTYPE=$(LFLAGS_NOCONSOLE)
CRT_STARTUP=$(CRT_STARTUP_NOCONSOLE)

CFLAGS_LOCAL=$(CFLAGS_APPTYPE) -DSTARTUP_CLASS="\"%(STARTUP_CLASS)\"" -DSTARTUP_SELECTOR="\"%(STARTUP_SELECTOR)\"" -DUSE_MODULE_TABLE

TOP=%(TOP)       

#
OBJS=%(OBJECTS)

!!INCLUDE $(TOP)\rules\stdHeader_nt
#
MODULE=%(MODULE)
MODULE_DIR=%(MODULE_DIRECTORY)
PACKAGE=$(MODULE):$(MODULE_DIR)
LIBNAME=dummy
STCOPT="+optinline"
STCLOCALOPT=-package=$(PACKAGE) $(COMMONSYMBOLS) $(SEPINITCODE) $(RELOCINSTVARS) -varPrefix=$(LIBNAME)
#STCLOCALOPT=""

LINKER = ilink32

# LFLAGS = -L$(TOP)\libbc;$(BCB)\lib;$(DEBUGLIBPATH) -H:0x400000 -Hc:0x100000 -S:0x40000 -Sc:0x10000 -ap -Tpe -x -Gn -v -Ao:0x10000
LFLAGS = -L$(TOP)\libbc;$(BCB)\lib -S:0x40000 -Sc:0x10000 $(LFLAGS_APPTYPE) -Tpe -x -Gn -v -Ao:0x10000

PROJECT = %(APPLICATION).exe
#ALLOBJFILES = stx.obj main.obj
ALLOBJFILES = main.obj
RESFILES = %(APPLICATION)WinRC.res
ALLOBJ = $(CRT_STARTUP) $(ALLOBJFILES) $(OBJS)
DEFFILE=bc.def

LIBFILES=$(TOP)\libbc\librun.lib
ALLLIB=$(LIBFILES) import32.lib $(RT_LIB)

REQUIRED_LIBS=librun.dll %(REQUIRED_LIBS)
REQUIRED_FILES=cs3245.dll symbols.stc $(REQUIRED_LIBS)

REQUIRED_SUPPORT_DIRS=%(REQUIRED_SUPPORT_DIRS)

ALL:: $(OBJS) $(REQUIRED_FILES) show $(PROJECT) $(REQUIRED_SUPPORT_DIRS)

setup: install_%(APPLICATION).exe

# This uses the Nullsoft Installer Package and works in Windows only

install_%(APPLICATION).exe: $(PROJECT) %(APPLICATION).nsi
    makensis %(APPLICATION).nsi

new:
    bmake clean
    bmake

%(RESOURCE_RULES)

%(PREREQUISITES_LIBS)      
%(SUBPROJECTS_LIBS)

show:
    @echo LFLAGS= $(LFLAGS)
    @echo ALLOBJ= $(ALLOBJ)
    @echo PROJECT= $(PROJECT)
    @echo ALLLIB= $(ALLLIB)
    @echo DEFFILE= $(DEFFILE)
    @echo ALLRES= $(ALLRES)

$(PROJECT): $(ALLOBJFILES) $(OBJS) $(RESFILES) $(DEFFILE)
    $(BCB)\BIN\$(LINKER) $(LFLAGS) $(ALLOBJ), $(PROJECT),,  $(ALLLIB),  $(DEFFILE),  $(RESFILES)

#$(PROJECT): $(ALLOBJFILES) $(RESFILES) $(DEFFILE)
#    $(BCB)\BIN\$(LINKER) @&&!!
#    $(LFLAGS) +
#    $(ALLOBJ), +
#    $(PROJECT),, +
#    $(ALLLIB), +
#    $(DEFFILE), +
#    $(RESFILES)
#!!


!!INCLUDE $(TOP)\rules\stdRules_nt

#
# additional rules
#

stx.obj: $(TOP)\librun\objbc\stx.obj
        copy $(TOP)\librun\objbc\stx.obj stx.obj

%(APPLICATION)WinRC.res: %(APPLICATION)WinRC.rc %(APPLICATION).ico

main.obj: buildDate.h main.c nt.mak

main.c:        $(TOP)\librun\main.c
        copy $(TOP)\librun\main.c main.c

buildDate.h: genDate.exe
        genDate.exe

genDate.exe:        $(TOP)\librun\genDate.exe
        copy $(TOP)\librun\genDate.exe genDate.exe

librun.dll: $(TOP)\librun\librun.dll
        copy $(TOP)\librun\librun.dll librun.dll

cs3245.dll: $(TOP)\support\win32\borland\cs3245.dll
        copy $(TOP)\support\win32\borland\cs3245.dll cs3245.dll

symbols.stc: $(TOP)\include\symbols.stc
        copy $(TOP)\include\symbols.stc symbols.stc

clean::
        -del genDate.exe
        -del c0x32.dll
        -del c0x32.lib
        -del buildDate.h
        -del $(PROJECT)
        -del install_%(APPLICATION).exe
        -del stx.lib
        -del stx.dll
        -del librun.dll
        -del cs3245.dll
        -del $(REQUIRED_FILES)
        -del main.c
        -del *.log
        -rmdir /S /Q resources
        -rmdir /S /Q objbc

# BEGINMAKEDEPEND --- do not remove this line; make depend needs it
%(STARTUP_CLASS).$(O) %(STARTUP_CLASS).$(H): %(STARTUP_CLASS).st $(STCHDR)  ../../../stx/include/Object.$(H)
genAbbrev:: %(STARTUP_CLASS).st
# ENDMAKEDEPEND --- do not remove this line
'.

        ^ def.
!

nt_dot_mak_resource_rules
    ^ '

RESOURCEFILES: %(APPLICATION)_RESOURCES stx_RESOURCES stx_STYLES stx_BITMAPS

%(APPLICATION)_RESOURCES: resources\%(MODULE)\%(APPLICATION)\NUL
        copy ..\resources\*.rs resources\%(MODULE)\%(APPLICATION)\*.*

stx_RESOURCES: \
        libbasic_RESOURCES \
        libtool_RESOURCES  \
        libtool2_RESOURCES  \
        libview_RESOURCES  \
        libview2_RESOURCES

stx_STYLES: resources\stx\libview\NUL
        copy $(TOP)\libview\styles\mswindowsXP* resources\stx\libview\*.*
        copy $(TOP)\libview\styles\mswindows*.common resources\stx\libview\*.*

stx_BITMAPS: \
        libwidg_BITMAPS

libwidg_BITMAPS: resources\stx\libwidg\bitmaps\NUL
        copy $(TOP)\libwidg\bitmaps\*.xpm resources\stx\libwidg\bitmaps\*.*

libbasic_RESOURCES: resources\stx\libbasic\NUL
        copy $(TOP)\libbasic\resources\*.rs resources\stx\libbasic\*.*

libtool_RESOURCES: resources\stx\libtool\NUL
        copy $(TOP)\libtool\resources\*.rs resources\stx\libtool\*.*

libtool2_RESOURCES: resources\stx\libtool2\NUL
        copy $(TOP)\libtool2\resources\*.rs resources\stx\libtool2\*.*

libview_RESOURCES: resources\stx\libview\NUL
        copy $(TOP)\libview\resources\*.rs resources\stx\libview\*.*

libview2_RESOURCES: resources\stx\libview2\NUL
        copy $(TOP)\libview2\resources\*.rs resources\stx\libview2\*.*

resources\stx\libbasic\NUL: resources\stx\NUL
        mkdir resources\stx\libbasic

resources\stx\libtool\NUL: resources\stx\NUL
        mkdir resources\stx\libtool

resources\stx\libtool2\NUL: resources\stx\NUL
        mkdir resources\stx\libtool2

resources\stx\libview\NUL: resources\stx\NUL
        mkdir resources\stx\libview

resources\stx\libview2\NUL: resources\stx\NUL
        mkdir resources\stx\libview2

resources\stx\libwidg\bitmaps\NUL: resources\stx\libwidg\NUL
        mkdir resources\stx\libwidg\bitmaps

resources\stx\libwidg\NUL: resources\stx\NUL
        mkdir resources\stx\libwidg

resources\stx\NUL: resources\NUL
        mkdir resources\stx

resources\%(MODULE)\%(APPLICATION)\NUL: resources\%(MODULE)\NUL
        mkdir resources\%(MODULE)\%(APPLICATION)

resources\%(MODULE)\NUL: resources\NUL
        mkdir resources\%(MODULE)

resources\NUL:
        mkdir resources

bitmaps\NUL:
        mkdir bitmaps

doc\NUL:
        mkdir doc

'.
!

preRequisiteLine_nt_dot_mak

^'%(FILE_NAME).dll: $(TOP)\%(MODULE_DIRECTORY)\objbc\%(FILE_NAME).dll
        copy $(TOP)\%(MODULE_DIRECTORY)\objbc\%(FILE_NAME).dll *.*
'
!

subProjectLine_nt_dot_mak

^'%(LIBRARY_NAME).dll: $(TOP)\..\%(PATH_TO_SUB_PROJECT)\objbc\%(LIBRARY_NAME).dll
        copy $(TOP)\..\%(PATH_TO_SUB_PROJECT)\objbc\%(LIBRARY_NAME).dll *.*

$(TOP)\..\%(PATH_TO_SUB_PROJECT)\objbc\%(LIBRARY_NAME).dll:
        cd $(TOP)\..\%(PATH_TO_SUB_PROJECT)
        bmake
        -cd $(TOP)\..\%(PATH_TO_MYPROJECT)
'
! !

!ApplicationDefinition class methodsFor:'mappings'!

modules_dot_stx_mappings
    |d|

    d := Dictionary new.
    d 
        at: #'PREREQUISITE_LIBS' put: [self generatePreRequisiteLibs_modules_dot_stx]; 
        at: #'SUBPROJECT_LIBS' put: [self generateSubProjectLines_modules_dot_stx  ]. 

    ^ d
!

nt_dot_mak_mappings
    |d|

    d := Dictionary new.
    d 
        at: #'APPLICATION' put: [self applicationName];    
        at: #'STARTUP_CLASS' put: [ self startUpClass];
        at: #'STARTUP_SELECTOR' put: [self startUpSelector];
        at: #'TOP' put: [self msdosPathToTop];
        at: #'OBJECTS' put: [self generateObjects_nt_dot_mak];
        at: #'MODULE' put: [self module];  
        at: #'MODULE_DIRECTORY' put: [self moduleDirectory]; 
        at: #'REQUIRED_LIBS' put: [self generateRequiredLibs_nt_dot_mak]; 
        at: #'PREREQUISITES_LIBS' put: [self generatePreRequisiteLines_nt_dot_mak  ];  
        at: #'SUBPROJECTS_LIBS' put: [self generateSubProjectLines_nt_dot_mak  ]. 

    self needResources ifTrue:[
        d 
            at: #'REQUIRED_SUPPORT_DIRS' put: 'RESOURCEFILES'.
        d
            at: #'RESOURCE_RULES' put:( self replaceMappings: d 
                                            in: self nt_dot_mak_resource_rules ).
    ].
    ^ d
!

preRequisiteLine_nt_dot_mak_mappings: aProjectID 

^Dictionary new
    at: #'FILE_NAME' put: [ProjectDefinition packageNameFor: aProjectID ];  
    at: #'MODULE_DIRECTORY' put: [ProjectDefinition moduleDirectoryFor: aProjectID ];     
    yourself
!

preRequisiteLine_nt_dot_mak_mappingsForClass:aClass

^Dictionary new
    at: #'FILE_NAME' put: [ aClass classFilename asFilename withoutSuffix baseName ];  
    at: #'MODULE_DIRECTORY' put: [ProjectDefinition moduleDirectoryFor: aClass package ];     
    yourself
!

subProjectLine_nt_dot_mak_mappings: aProjectID 

^Dictionary new
    at: #'LIBRARY_NAME' put: [ProjectDefinition libraryNameFor: aProjectID ];     
    at: #'PATH_TO_SUB_PROJECT' put: [ProjectDefinition msdosPathToProjectFor: aProjectID ]; 
    at: #'PATH_TO_MYPROJECT' put: [ProjectDefinition msdosPathToProjectFor: self package ]; 
yourself
! !

!ApplicationDefinition class methodsFor:'mappings support'!

generateObjects_nt_dot_mak

^self objectsClassNames
    inject: ''
    into:[:objectLines :objectClassName |    
        objectLines , ' ', objectClassName ,'.obj'
    ]

"
    bosch_dapasx_Application generateObjects_nt_dot_mak     
"
!

generatePreRequisiteLibs_modules_dot_stx
    |string|

    string := String streamContents:[:s |
            self preRequisites do:[:projectID | 
                    (projectID startsWith:'stx:') ifTrue:[
                        s nextPutLine:(ProjectDefinition packageNameFor:projectID)
                    ] ifFalse:[
                       s nextPutLine:(ProjectDefinition libraryNameFor:projectID)
                    ]
                ].
                self isGUIApplication ifTrue:[
                    self guiClassFileNames do:[:eachFilename |
                        s nextPutLine:(eachFilename asFilename withoutSuffix baseName)
                    ].
                ].
            ].

    ^ string

    "
        bosch_dapasx_application generatePreRequisiteLibs_modules_dot_stx
    "
!

generatePreRequisiteLines_nt_dot_mak         

    ^ String streamContents:[:s |
        self preRequisites do:[:eachPackage |
            |mappings newObjectLine|
            mappings := self preRequisiteLine_nt_dot_mak_mappings: eachPackage.
            newObjectLine := self replaceMappings: mappings
                                in: self preRequisiteLine_nt_dot_mak.
            s nextPutAll:newObjectLine. 
            s cr. 
        ].
        self guiClasses do:[:eachClass |
            |mappings newObjectLine|
            mappings := self preRequisiteLine_nt_dot_mak_mappingsForClass: eachClass.
            newObjectLine := self replaceMappings: mappings
                                in: self preRequisiteLine_nt_dot_mak.
            s nextPutAll:newObjectLine. 
            s cr. 
        ].

    ]
"
    bosch_dapasx_Application generatePreRequisiteLines_make_dot_spec 

"

    "Created: / 09-08-2006 / 11:24:39 / fm"
!

generateRequiredLibs_nt_dot_mak
    |string|

    string := self preRequisites inject:''
                into:[:prereqString :projectID | 
                    prereqString , ' ' , (ProjectDefinition packageNameFor:projectID) , '.dll'
                ].

    self isGUIApplication ifTrue:[
        self guiClassFileNames do:[:eachFilename |
            string := string , ' ',eachFilename
        ].
    ].
    ^ self subProjects inject:string
        into:[:prereqString :projectID | 
            prereqString , ' ' , (ProjectDefinition libraryNameFor:projectID) , '.dll'
        ].

    "
        bosch_dapasx_application generateRequiredLibs_nt_dot_mak
    "
!

generateSubProjectLines_modules_dot_stx
    |string|

    string := String streamContents:[:s |
            self subProjects do:[:projectID | 
                    (projectID startsWith:'stx:') ifTrue:[
                        s nextPutLine:(ProjectDefinition packageNameFor:projectID)
                    ] ifFalse:[
                       s nextPutLine:(ProjectDefinition libraryNameFor:projectID)
                    ]
                ].
            ].

    ^ string

    "
        bosch_dapasx_application generateSubProjectLines_modules_dot_stx
    "
!

generateSubProjectLines_nt_dot_mak         

    ^ String streamContents:[:s |
        self subProjects do:[:eachClass |
            |mappings newObjectLine|
            mappings := self subProjectLine_nt_dot_mak_mappings: eachClass.
            newObjectLine := self replaceMappings: mappings
                                in: self subProjectLine_nt_dot_mak.
            s nextPutAll:newObjectLine. 
            s cr. 
        ]
    ]
"
    bosch_dapasx_application generateSubProjectLinesnt_dot_mak 

"

    "Created: / 09-08-2006 / 11:24:39 / fm"
! !

!ApplicationDefinition class methodsFor:'update description'!

forEachMethodsCodeToCompileDo:aTwoArgBlock
    aTwoArgBlock 
        value:self subProjectsGeneratedCodeToCompile
        value:'description'.

    aTwoArgBlock 
        value:self preRequisitesGeneratedCodeToCompile
        value:'description'.

"/   aTwoArgBlock 
"/        value: 'description ^''bla bla'''
"/        value: 'description'

    "Created: / 10-08-2006 / 16:35:47 / cg"
!

preRequisitesGeneratedCodeToCompile
    |preRequisitesCode|

   preRequisitesCode := 'preRequisites', String lf, '"This method has been updated automatically"'.
   preRequisitesCode := preRequisitesCode, String lf, self preRequisitesGeneratedString. 
   ^preRequisitesCode


    "Created: / 08-08-2006 / 15:07:06 / fm"
!

preRequisitesGeneratedString
    |preRequisites|
    preRequisites := self preRequisites asSet.
    preRequisites addAll: self searchForPreRequisites keys.
    preRequisites removeAll: self excludedFromPreRequisites.
    ^ String streamContents:[:s |
        s nextPutAll:'^#('.
        preRequisites do:[:eachClass |    
                    s cr; nextPutAll:eachClass asString storeString
        ].      
        s cr; nextPutAll:')'
    ].

"
    bosch_dapasx_Application preRequisitesGeneratedString
"

    "Created: / 08-08-2006 / 15:00:17 / fm"
    "Modified: / 08-08-2006 / 19:24:34 / fm"
!

searchForPreRequisites
    |includedClasses requiredPackages usedClasses reasons allSubProjects|

    requiredPackages := Dictionary new.
    usedClasses := Dictionary new.
    includedClasses := (self subProjects inject: OrderedCollection new
                                         into:[:collection :projectID | 
                                                collection addAll: (ProjectDefinition searchForClassesWithProject: projectID asSymbol);
                                                                yourself
                                         ]
                        ) asSet.
    includedClasses 
        do:[:cls | 
                cls allSuperclassesDo:[:superClass |    
                        reasons := usedClasses at: superClass ifAbsentPut:[Set new].
                        reasons add: superClass name, ' - Superclass of ', cls name.
                ]
        ].
    includedClasses addAll: usedClasses keys.
    includedClasses 
        do:[:includedClass |
            includedClass methodsDo:[:method | 
                    method usedGlobals 
                            do:[:global | |usedClass|        
                                    usedClass := Smalltalk at: global asSymbol. 
                                    (usedClass notNil and:[usedClass isClass and:[usedClass isNameSpace not]]) 
                                        ifTrue:[
                                                reasons := usedClasses at: usedClass ifAbsentPut:[Set new].
                                                reasons add: usedClass name, ' - Referenced by ', includedClass name,'>>',method name
                                        ]
                            ]
            ]
        ].
    allSubProjects := self searchForSubProjects.
    usedClasses 
        keysAndValuesDo:[:usedClass :reasonsPerClass |           
                (allSubProjects includes: usedClass package asString)
                        ifFalse:[
                                usedClass package == Project noProjectID 
                                        ifFalse:[reasons := requiredPackages at:usedClass package ifAbsentPut:[Set new].
                                                 reasons addAll:reasonsPerClass.] 
                        ].
        ].
    ^requiredPackages

"
    self searchForPreRequisites
    bosch_dapasx_Application searchForPreRequisites
"

    "Created: / 07-08-2006 / 20:42:39 / fm"
    "Modified: / 07-08-2006 / 21:56:25 / fm"
!

searchForSubProjects

    ^ Smalltalk allProjectIDs select:[:projectID | 
        (ProjectDefinition parentProjectFor: projectID) = (ProjectDefinition parentProjectFor: self package)].

"
    self searchForSubProjects
    bosch_dapasx_Application searchForSubProjects
"

    "Created: / 07-08-2006 / 20:42:39 / fm"
    "Modified: / 07-08-2006 / 21:56:25 / fm"
!

subProjectsGeneratedCodeToCompile
    |subProjectsCode|

   subProjectsCode := 'subProjects', String lf, '"This method has been automatically generated"'.
   subProjectsCode := subProjectsCode, String lf, self subProjectsGeneratedString. 
   ^subProjectsCode

"
    DapasXProject Datenbasis
    DapasX_Datenbasis Datenbasis

"

    "Created: / 08-08-2006 / 15:07:06 / fm"
!

subProjectsGeneratedString         
    |subProjects|
    subProjects := self searchForSubProjects.
    subProjects removeAll: self excludedFromSubProjects.
    ^ String streamContents:[:s |
        s nextPutAll:'^#('.
        subProjects do:[:eachClass |    
                    s cr; nextPutAll:eachClass asString storeString
        ].      
        s cr; nextPutAll:')'
    ].

"
    bosch_dapasx_Application subProjectsGeneratedString
"

    "Created: / 08-08-2006 / 15:00:17 / fm"
    "Modified: / 08-08-2006 / 19:24:34 / fm"
! !

!ApplicationDefinition class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic/ApplicationDefinition.st,v 1.4 2006-08-16 15:59:07 fm Exp $'
! !
